[LeetCode] 10. Regular Expression Matching 正則表達式匹配

 

Given an input string (s) and a pattern (p), implement regular expression matching with support for '.' and '*'.html

'.' Matches any single character.
'*' Matches zero or more of the preceding element.

The matching should cover the entire input string (not partial).git

Note:github

  • s could be empty and contains only lowercase letters a-z.
  • p could be empty and contains only lowercase letters a-z, and characters like . or *.

Example 1:正則表達式

Input:
s = "aa"
p = "a"
Output: false
Explanation: "a" does not match the entire string "aa".

Example 2:express

Input:
s = "aa"
p = "a*"
Output: true
Explanation: '*' means zero or more of the precedeng element, 'a'. Therefore, by repeating 'a' once, it becomes "aa".

Example 3:數組

Input:
s = "ab"
p = ".*"
Output: true
Explanation: ".*" means "zero or more (*) of any character (.)".

Example 4:函數

Input:
s = "aab"
p = "c*a*b"
Output: true
Explanation: c can be repeated 0 times, a can be repeated 1 time. Therefore it matches "aab".

Example 5:post

Input:
s = "mississippi"
p = "mis*is*p*."
Output: false

 

這道求正則表達式匹配的題和那道 Wildcard Matching 的題很相似,不一樣點在於*的意義不一樣,在以前那道題中,*表示能夠代替任意個數的字符,而這道題中的*表示以前那個字符能夠有0個,1個或是多個,就是說,字符串 a*b,能夠表示b或是 aaab,即a的個數任意,這道題的難度要相對以前那一道大一些,分的狀況的要複雜一些,須要用遞歸 Recursion 來解,大概思路以下:url

- 若p爲空,若s也爲空,返回 true,反之返回 false。spa

- 若p的長度爲1,若s長度也爲1,且相同或是p爲 '.' 則返回 true,反之返回 false。

- 若p的第二個字符不爲*,若此時s爲空返回 false,不然判斷首字符是否匹配,且從各自的第二個字符開始調用遞歸函數匹配。

- 若p的第二個字符爲*,進行下列循環,條件是若s不爲空且首字符匹配(包括 p[0] 爲點),調用遞歸函數匹配s和去掉前兩個字符的p(這樣作的緣由是假設此時的星號的做用是讓前面的字符出現0次,驗證是否匹配),若匹配返回 true,不然s去掉首字母(由於此時首字母匹配了,咱們能夠去掉s的首字母,而p因爲星號的做用,能夠有任意個首字母,因此不須要去掉),繼續進行循環。

- 返回調用遞歸函數匹配s和去掉前兩個字符的p的結果(這麼作的緣由是處理星號沒法匹配的內容,好比 s="ab", p="a*b",直接進入 while 循環後,咱們發現 "ab" 和 "b" 不匹配,因此s變成 "b",那麼此時跳出循環後,就到最後的 return 來比較 "b" 和 "b" 了,返回 true。再舉個例子,好比 s="", p="a*",因爲s爲空,不會進入任何的 if 和 while,只能到最後的 return 來比較了,返回 true,正確)。

 

解法一:

class Solution {
public:
    bool isMatch(string s, string p) {
        if (p.empty()) return s.empty();
        if (p.size() == 1) {
            return (s.size() == 1 && (s[0] == p[0] || p[0] == '.'));
        }
        if (p[1] != '*') {
            if (s.empty()) return false;
            return (s[0] == p[0] || p[0] == '.') && isMatch(s.substr(1), p.substr(1));
        }
        while (!s.empty() && (s[0] == p[0] || p[0] == '.')) {
            if (isMatch(s, p.substr(2))) return true;
            s = s.substr(1);
        }
        return isMatch(s, p.substr(2));
    }
};

 

上面的方法能夠寫的更加簡潔一些,可是整個思路仍是同樣的,先來判斷p是否爲空,若爲空則根據s的爲空的狀況返回結果。當p的第二個字符爲*號時,因爲*號前面的字符的個數能夠任意,能夠爲0,那麼咱們先用遞歸來調用爲0的狀況,就是直接把這兩個字符去掉再比較,或者當s不爲空,且第一個字符和p的第一個字符相同時,再對去掉首字符的s和p調用遞歸,注意p不能去掉首字符,由於*號前面的字符能夠有無限個;若是第二個字符不爲*號,那麼就老老實實的比較第一個字符,而後對後面的字符串調用遞歸,參見代碼以下:

 

解法二:

class Solution {
public:
    bool isMatch(string s, string p) {
        if (p.empty()) return s.empty();
        if (p.size() > 1 && p[1] == '*') {
            return isMatch(s, p.substr(2)) || (!s.empty() && (s[0] == p[0] || p[0] == '.') && isMatch(s.substr(1), p));
        } else {
            return !s.empty() && (s[0] == p[0] || p[0] == '.') && isMatch(s.substr(1), p.substr(1));
        }
    }
};

 

咱們也能夠用 DP 來解,定義一個二維的 DP 數組,其中 dp[i][j] 表示 s[0,i) 和 p[0,j) 是否 match,而後有下面三種狀況(下面部分摘自這個帖子):

1.  P[i][j] = P[i - 1][j - 1], if p[j - 1] != '*' && (s[i - 1] == p[j - 1] || p[j - 1] == '.');
2.  P[i][j] = P[i][j - 2], if p[j - 1] == '*' and the pattern repeats for 0 times;
3.  P[i][j] = P[i - 1][j] && (s[i - 1] == p[j - 2] || p[j - 2] == '.'), if p[j - 1] == '*' and the pattern repeats for at least 1 times.


解法三:

class Solution {
public:
    bool isMatch(string s, string p) {
        int m = s.size(), n = p.size();
        vector<vector<bool>> dp(m + 1, vector<bool>(n + 1, false));
        dp[0][0] = true;
        for (int i = 0; i <= m; ++i) {
            for (int j = 1; j <= n; ++j) {
                if (j > 1 && p[j - 1] == '*') {
                    dp[i][j] = dp[i][j - 2] || (i > 0 && (s[i - 1] == p[j - 2] || p[j - 2] == '.') && dp[i - 1][j]);
                } else {
                    dp[i][j] = i > 0 && dp[i - 1][j - 1] && (s[i - 1] == p[j - 1] || p[j - 1] == '.');
                }
            }
        }
        return dp[m][n];
    }
};

 

GitHub 同步地址:

https://github.com/grandyang/leetcode/issues/10

 

相似題目:

Wildcard Matching

 

參考資料:

https://leetcode.com/problems/regular-expression-matching/

https://leetcode.com/problems/regular-expression-matching/discuss/5684/9-lines-16ms-c-dp-solutions-with-explanations

https://leetcode.com/problems/regular-expression-matching/discuss/5665/my-concise-recursive-and-dp-solutions-with-full-explanation-in-c

 

LeetCode All in One 題目講解彙總(持續更新中...)

相關文章
相關標籤/搜索